checkRequire("Lua_UserDefinedWindow");
checkRequire("Lua_OutTimeItem");
Lua_HangUpPanel = class("Lua_HangUpPanel", Lua_DisplayObject);
function Lua_HangUpPanel:ctor(p)
	self:superCall("ctor", p, "HangUpBasicPanel_skin", true);
end

function Lua_HangUpPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(-63, 5, 1120, 534));
	self.dragContainer:setLocation(0, 0, 0);
	self.dragContainer.uiPanel.depth = 3000;
	self.draggableHangUpPanel = Lua_DraggableHangUpPanel.new(self.dragContainer);

	self.helpBtn:addClickFuntion(self, self.onHelpClick);

	self.outTimeItem = Lua_OutTimeItem.new(self.content);
	self.outTimeItem.label.fontSize = 26;
	self.outTimeItem.label:SetDimensions(200, 26);
	self.outTimeItem.countingTxt.fontSize = 26;
	self.outTimeItem.countingTxt:SetDimensions(100, 26);
	self.outTimeItem.countingTxt:setLocation(-410, -172, 0);
	self.outTimeItem:setLocation(450, -133, 0);
end
function Lua_HangUpPanel:labelClick(go)
	
end

function Lua_HangUpPanel:onHelpClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow",nil,LanUtil.getValue(110235));
end

function Lua_HangUpPanel:dispose()
	if(self.dragContainer~=nil) then 
		self.dragContainer:dispose(); 
		self.dragContainer=nil; 
	end
	if(self.draggableHangUpPanel~=nil) then
		self.draggableHangUpPanel:dispose();
		self.draggableHangUpPanel =nil;
	end
	self:superCall("dispose");
end

Lua_DraggableHangUpPanel = class("Lua_HangUpPanel", Lua_DragContainerItem);
function Lua_DraggableHangUpPanel:ctor(dragContainer)
	self.isInit = false;
	self:superCall("ctor", dragContainer.sub, "HangUpPanel_skin", true);
	dragContainer:addSubContainer(self,true);
end
function Lua_DraggableHangUpPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("HANGUP_PANEL_UPDATE", self, self.updatePanel);

	self.autoRtxt.text = LanUtil.getValue(110233);
	self.autoRtxt.clickScale = false;

	self:setPrg(self.hpPrg,100,70,self.onHpSlideing,self.onHpSlideing);
	self:setPrg(self.mpPrg,100,40,self.onMpSlideing,self.onMpSlideing);

	self.selectedRadioBtn = nil;

	self.radioBtnImg1:addClickFuntion(self,self.onRadioListClick1);
	self.radioBtnLabel1:addClickFuntion(self,self.onRadioListClick1);
	self.radioBtnLabel1.clickScale = false;

	self.radioBtnImg2:addClickFuntion(self,self.onRadioListClick2);
	self.radioBtnLabel2:addClickFuntion(self,self.onRadioListClick2);
	self.radioBtnLabel2.clickScale = false;
	self.radioBtnList = Array();

	self.autoPickUpChk_green:addBoxChange(self, self.onAutoPickChange1);
	self.autoPickUpChk_blue:addBoxChange(self, self.onAutoPickChange2);
	self.autoPickUpChk_purple:addBoxChange(self, self.onAutoPickChange3);
	self.autoPickUpChk_orange:addBoxChange(self, self.onAutoPickChange4);

	self.autoPickUpItemChk1:addBoxChange(self, self.onOutLineStateChange1);
	self.autoPickUpItemChk2:addBoxChange(self, self.onOutLineStateChange2);
	self.autoPickUpItemChk3:addBoxChange(self, self.onOutLineStateChange3);

	self.autoUseDragChk:addBoxChange(self, self.onAutoDrugChange);
	self.autoBuyDragChk:addBoxChange(self, self.onAutoBuyDrugChange);

	self.autoRimg:addClickFuntion(self, self.onAutoResurrenctionChange);
	self.autoRtxt:addClickFuntion(self, self.onAutoResurrenctionChange);
	self.autoAvoidBossChk:addBoxChange(self, self.onAutoAvoidBossChange);
	self.autoJueXingChk:addBoxChange(self, self.onAutoJueXingChange);

	self.autoDefineRangeChk:addBoxChange(self, self.onRange1Change);
	self.sysRecommendationChk:addBoxChange(self, self.onRange2Change);

	self.autoSellEqp:addBoxChange(self, self.onAutoSellEqu);
	self.autoEatEqp:addBoxChange(self, self.onAutoEatEqu);

	self.radioBtnList:add(self.radioBtnImg1);
	self.radioBtnList:add(self.radioBtnImg2);

	self.autoEatEqp.label = LanUtil.getValue(110242);

	self:updatePanel();
end
function Lua_DraggableHangUpPanel:updatePanel()
	local sdata = DataCenter.hangUpSettingsData;
	self:setUseDrug(sdata.auto_drug);
	self:setOutLineHang(sdata.hook_monster_sort);
	self.autoBuyDragChk.seleted = sdata.auto_buy_drug == 1;
	self.hpPrg:setMaxValue(99);
	self.hpPrg:setValue(sdata.auto_drug_blood);
	self.mpPrg:setMaxValue(99);
	self.mpPrg:setValue(sdata.auto_drug_magic);

	if sdata.relive_type == 1 then
		self.autoRimg:setAltas("common_atlas_1","ui_common_widget_gouxuan");
	else
		self.autoRimg:setAltas("common_atlas_1","ui_common_widget_gouxuan2");
	end
	self.autoAvoidBossChk.seleted = sdata.auto_avoid_boss == 1;
	self:setAutoPick(sdata.auto_pick_color);
	self:setOutLineState(sdata.hook_pk_state);

	self.autoSellEqp.seleted = sdata.auto_sell == 1;
	self.autoEatEqp.seleted = sdata.auto_eat_equipt == 1;
	self.autoJueXingChk.seleted = sdata.auto_call_beast == 1;

	self.isInit = true;
end
function Lua_DraggableHangUpPanel:onAutoResurrenctionChange(val)
	local urlStr = self.autoRtxt:getUrlByMousePos()
	if urlStr ~= nil then
		local arr = string.split(urlStr, "_");
		local itemId = tonumber(arr[2]);
		local tvo = Lua_ToolVo.createToolVo(itemId);
		Lua_PackUtil.showItemInfo(tvo, false);
	else
		local sdata = DataCenter.hangUpSettingsData;
		if sdata.relive_type == 1 then
			sdata.relive_type = 0;
			self.autoRimg:setAltas("common_atlas_1","ui_common_widget_gouxuan2");
		else
			sdata.relive_type = 1;
			self.autoRimg:setAltas("common_atlas_1","ui_common_widget_gouxuan");
		end
	end
end
function Lua_DraggableHangUpPanel:onAutoAvoidBossChange(val)
	local sdata = DataCenter.hangUpSettingsData;
	sdata.auto_avoid_boss = val == true and 1 or 0;
end
function Lua_DraggableHangUpPanel:onAutoJueXingChange(val)
	local sdata = DataCenter.hangUpSettingsData;
	sdata.auto_call_beast = val == true and 1 or 0;
end
function Lua_DraggableHangUpPanel:onAutoSellEqu(val)
	local sdata = DataCenter.hangUpSettingsData;
	sdata.auto_sell = val == true and 1 or 0;
end
function Lua_DraggableHangUpPanel:onAutoEatEqu(val)
	local sdata = DataCenter.hangUpSettingsData;
	sdata.auto_eat_equipt = val == true and 1 or 0;
end
function Lua_DraggableHangUpPanel:onRange1Change(val)
	self:setOutLineHang(1)
end
function Lua_DraggableHangUpPanel:onRange2Change(val)
	self:setOutLineHang(0)
end
function Lua_DraggableHangUpPanel:setOutLineHang(val)
	local sdata = DataCenter.hangUpSettingsData;
	self.autoDefineRangeChk.seleted = val == 1;
	self.sysRecommendationChk.seleted = val == 0;
	sdata.hook_monster_sort = val;
end
function Lua_DraggableHangUpPanel:setOutLineState(val)
	local sdata = DataCenter.hangUpSettingsData;
	self.autoPickUpItemChk1.seleted = val == 0;
	self.autoPickUpItemChk2.seleted = val == 1;
	self.autoPickUpItemChk3.seleted = val == 2;
	sdata.hook_pk_state = val;
end
function Lua_DraggableHangUpPanel:setUseDrug(val)
	local sdata = DataCenter.hangUpSettingsData;
	self.autoUseDragChk.seleted = val ~= 0;
	if val == 1 then
		self.radioBtnImg1:setAltas("common_atlas_2","ui_common_widget_1y");
		self.radioBtnImg2:setAltas("common_atlas_2","ui_common_widget_2y");
	elseif val == 2 then
		self.radioBtnImg1:setAltas("common_atlas_2","ui_common_widget_2y");
		self.radioBtnImg2:setAltas("common_atlas_2","ui_common_widget_1y");
	else
		self.radioBtnImg1:setAltas("common_atlas_2","ui_common_widget_2y");
		self.radioBtnImg2:setAltas("common_atlas_2","ui_common_widget_2y");
	end
	sdata.auto_drug = val;
end
function Lua_DraggableHangUpPanel:setAutoPick(val)
	self.autoPickUpChk_green.seleted = val == 1;
	self.autoPickUpChk_blue.seleted = val == 2;
	self.autoPickUpChk_purple.seleted = val == 3;
	self.autoPickUpChk_orange.seleted = val == 4;
	DataCenter.hangUpSettingsData.auto_pick_color = val;
	local pd = PlayerData.getInstance();
	pd:setSettingValue("PICK_ITEM", val);
end
function Lua_DraggableHangUpPanel:onAutoPickChange1(val)
	self:setAutoPick(1);
end
function Lua_DraggableHangUpPanel:onAutoPickChange2(val)
	self:setAutoPick(2);
end
function Lua_DraggableHangUpPanel:onAutoPickChange3(val)
	self:setAutoPick(3);
end
function Lua_DraggableHangUpPanel:onAutoPickChange4(val)
	self:setAutoPick(4);
end
function Lua_DraggableHangUpPanel:onPullDownClick(go)
	Lua_WindowUtil.openWin("Lua_OutLineRangeWindow");
end
function Lua_DraggableHangUpPanel:onAutoBuyDrugChange(val)
	local sdata = DataCenter.hangUpSettingsData;
	sdata.auto_buy_drug = val and 1 or 0;
end
function Lua_DraggableHangUpPanel:onAutoDrugChange(val)
	if val == true then
		self:setUseDrug(1);
	else
		self:setUseDrug(0);
	end
end
function Lua_DraggableHangUpPanel:onRadioListClick1(go)
	if self.autoUseDragChk.seleted == false then
		return;
	end
	self:setUseDrug(1);
end
function Lua_DraggableHangUpPanel:onRadioListClick2(go)
	if self.autoUseDragChk.seleted == false then
		return;
	end
	self:setUseDrug(2);
end

function Lua_DraggableHangUpPanel:setPrg(prg,maxValue,value,slideEndFun,slideingFun)
	if(self.prgList ==nil) then self.prgList=Array(); end
	self.prgList:add(prg);
	prg:setText("");
	prg:createSlider("settingsWindow_atlas","ui_shezhi_widget_01");
	prg:addSlideEndFun(self,slideEndFun);
	prg:addSlidingFun(self,slideingFun);
	prg:setMaxValue(maxValue);
	prg:setValue(value);
end

function Lua_DraggableHangUpPanel:onHpSlideing(val)
	local v = val <= 0 and 1 or val;
	if self.isInit == true then
		local sdata = DataCenter.hangUpSettingsData;
		sdata.auto_drug_blood = v;
	end
	self.hpLabel.text = LanUtil.formateStr(LanUtil.getValue(110219), tostring(v));
end
function Lua_DraggableHangUpPanel:onMpSlideing(val)
	local v = val <= 0 and 1 or val;
	if self.isInit == true then
		local sdata = DataCenter.hangUpSettingsData;
		sdata.auto_drug_magic = v;
	end
	self.mpLabel.text = LanUtil.formateStr(LanUtil.getValue(110220), tostring(v));
end

function Lua_DraggableHangUpPanel:onOutLineStateChange1(val)
	self:setOutLineState(0);
end
function Lua_DraggableHangUpPanel:onOutLineStateChange2(val)
	self:setOutLineState(1);
end
function Lua_DraggableHangUpPanel:onOutLineStateChange3(val)
	self:setOutLineState(2);
end
function Lua_DraggableHangUpPanel:onOutLineStateChange4(val)
	self:setOutLineState(3);
end

function Lua_DraggableHangUpPanel:getWidth()
	return 500;
end
function Lua_DraggableHangUpPanel:getHeight()
	return 1055;
end
