Lua_PrivatePushPanel = class("Lua_PrivatePushPanel", Lua_DisplayObject);

function Lua_PrivatePushPanel:ctor(p)
    self:superCall("ctor", p, "PrivatePushPanel_skin", true);
end
function Lua_PrivatePushPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.config = getConfig({"PrivatePush"});
    self.statetest=0;
    self.eventList=Array();
    self.freeFlay=0;
    self.default=false;
    self.timeBoxBtnBg:addClickFuntion(self,self.onLockBgClick);
    self.activitiesList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 605, 410));
    self.activitiesList:setLocation(-306, -45, 0);
    self.activitiesList:setListCell(Lua_ActivitiesPushItem, 72, 605, 1);
    --self.dragList.canDrag = true;

    self.hookList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 475, 340));
    self.hookList:setLocation(256, -79, 0);
    self.hookList:setListCell(Lua_HookPushItem, 60, 475, 1);

    self.dayTips.overflowMethod = UILabel.Overflow.ResizeFreely;
    self.mpLabel.text=LanUtil.getValue(128303);
    local freeTime=getConfig({"PrivatePush",40001,"begin_time"});
    self.hourstart.text=string.sub(freeTime,1,2);
    self.minstart.text=string.sub(freeTime,4,5);
    self.hourend.text=string.sub(freeTime,-5,-4);
    self.minend.text=string.sub(freeTime,-2,-1);
    self:setWinInfo(nil);
    Lua_ProxyManager.getProxy("Lua_PrivatePushProxy"):getPushWinInfo();
    self:addLuaEvent("setPushWinInfo", self, self.setWinInfo);
    self:addLuaEvent("setBtnState", self, self.setBtnListState);

end
function Lua_PrivatePushPanel:setBtnListState(listData)

    if self.eventList == nil then
        self.eventList=Array();
    end
    if listData.state==1 then
        self.eventList:add(listData.id);
    else
        self.eventList:removeItem(listData.id);
    end

end
function Lua_PrivatePushPanel:setWinInfo(data)
    self.data=data;
    if self.data == nil then
        self:setDefaultState();
        return;
    end
    local leftTime =tonumber(DataCenter.vipData.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
    local days=0;
    if leftTime >= 0 then
        days=math.ceil(leftTime/86400);
    end
    self.dayTips.text=LanUtil.formateStr(LanUtil.getValue(128301),tostring(days));--"[192e41]剩余天数：[-][26ba4c]"..days.."天[-]";
    if days <= 10 then
        self.dayTips.text=LanUtil.formateStr(LanUtil.getValue(128302),tostring(days));
    end
    if data.flag == 0 then
        self:setLockState(0);
    else
        self:setLockState(1);
    end
    local activiteList=Array();
    local otherList=Array();
    local state=0;
    self.eventList=Array();
    for k,v in pairs(self.config) do
        state=0;
        if data.listen_msg~=nil and #data.listen_msg>0 then
            for i = 1, #data.listen_msg do
                if tonumber(k) == tonumber(data.listen_msg[i]) then
                    state=1;
                    self.eventList:add(data.listen_msg[i]);
                end
            end
        end
        if tonumber(v.msg_type) == 1 then
            local dic={};
            dic.id=k;
            dic.state=state;
            dic.desc=v.desc;
            dic.days=v.days;
            dic.begin_time=v.begin_time;
            dic.vipLvl=v.vip_level;
            activiteList:add(dic);
        elseif tonumber(v.msg_type) ==3 then
            local dic2={};
            dic2.id=k;
            dic2.state=state;
            dic2.desc=v.desc;
            dic2.vipLvl=v.vip_level;
            otherList:add(dic2);
        end
    end
    activiteList:sort("id",false);
    otherList:sort("id",false);
    self.activitiesList:setLuaArrayData(activiteList,false);
    self.hookList:setLuaArrayData(otherList,false);
end
function Lua_PrivatePushPanel:setDefaultState()

    local days=0;
    self.dayTips.text=LanUtil.formateStr(LanUtil.getValue(128302),tostring(days));
    local defsta=getConfig({"PrivatePush",40001,"defaultState"});
    self:setLockState(defsta);

    local activiteList=Array();
    local otherList=Array();
    local state=false;
    for k,v in pairs(self.config) do
        state=false;
        if tonumber(v.msg_type) == 1 then
            local dic={};
            dic.id=k;
            dic.state=v.defaultState;
            dic.desc=v.desc;
            dic.days=v.days;
            dic.begin_time=v.begin_time;
            dic.vipLvl=v.vip_level;
            activiteList:add(dic);
        elseif tonumber(v.msg_type) ==3 then
            local dic2={};
            dic2.id=k;
            dic2.state=v.defaultState;
            dic2.desc=v.desc;
            dic2.vipLvl=v.vip_level;
            otherList:add(dic2);
        end
    end
    activiteList:sort("id",false);
    otherList:sort("id",false);
    self.activitiesList:setLuaArrayData(activiteList,false);
    self.hookList:setLuaArrayData(otherList,false);
end
function Lua_PrivatePushPanel:onLockBgClick(go)
    local leftTime =tonumber(DataCenter.vipData.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
    local needVip=getConfig({"PrivatePush",40001,"vip_level"});
    if leftTime>0 and tonumber(DataCenter.vipData.level) >= needVip then
        if self.statetest == 0 then
            local tipData = {};
            tipData.des = LanUtil.getValue(128305);
            tipData.owner = self;
            tipData.type = 1;
            tipData.subFun = self.openFreePush;   --确定
            tipData.cancelFun = self.onSubClick;  -- 取消
            tipData.subName = LanUtil.getValue(11);
            tipData.cancelName = LanUtil.getValue(10016);
            Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
        else
            self:setLockState(0);
        end
    else
        local tipData = {};
        tipData.des = LanUtil.getValue(128304);
        tipData.owner = self;
        tipData.type = 1;
        tipData.subFun = self.openVIPWindow;   --确定
        tipData.cancelFun = self.onSubClick;  -- 取消
        tipData.subName = LanUtil.getValue(120862);
        tipData.cancelName = LanUtil.getValue(10016);
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
    end

end
function Lua_PrivatePushPanel:openFreePush()
    self:setLockState(1);
end
function Lua_PrivatePushPanel:openVIPWindow()
    Lua_WindowUtil.openWin("Lua_ChongzhiWindow",nil,10097);
    Lua_WindowUtil.openWin("Lua_SettingsWindow",WinParam.ACTION_CLOSE, nil);
end
function Lua_PrivatePushPanel:setLockState(val)
    self.statetest = val;
    if self.statetest == 1 then
        self.timeBoxBtn:setLocation(404.6,193.4,0);
        self.switchTips.text=LanUtil.getValue(128307);
        self.switchTips:setLocation(378,194,0);
        self.timeBoxBtnBg:setAltas("settingsWindow", "pushBoxBg_open");
    else
        self.timeBoxBtn:setLocation(356,193.4,0);
        self.switchTips.text=LanUtil.getValue(128308);
        self.switchTips:setLocation(401,194,0);
        self.timeBoxBtnBg:setAltas("settingsWindow", "pushBoxBg");
    end
end

function Lua_PrivatePushPanel:dispose()
    if self.activitiesList~=nil then
        self.activitiesList:dispose();
        self.activitiesList=nil;
    end
    if self.hookList~=nil then
        self.hookList:dispose();
        self.hookList=nil;
    end
    Lua_ProxyManager.getProxy("Lua_PrivatePushProxy"):getPushEdite(self.eventList,self.statetest);
    self:superCall("dispose");
end




------------------------------------------------------
Lua_ActivitiesPushItem = class("Lua_ActivitiesPushItem", Lua_ListCell);
function Lua_ActivitiesPushItem:ctor(p)
    self:superCall("ctor", p, "ActivitiesPushItem_skin");
end
function Lua_ActivitiesPushItem:buildShowItem()
    self:superCall("buildShowItem");
    self.btnBg:addClickFuntion(self,self.onLockBgClick);
    self.timeLb:setLocation(128,0,0);
end
function Lua_ActivitiesPushItem:setData(data)
    self.data = data;
    if self.data==nil then
        return;
    end
    self.nameLb.text=self.data.desc;
    self.cycleLb.text=self.data.days;
    self.timeLb.text=tostring(self.data.begin_time);
    self:setLockState(self.data.state);
end

function Lua_ActivitiesPushItem:onLockBgClick(go)
    local leftTime =tonumber(DataCenter.vipData.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
    local needVip=getConfig({"PrivatePush",self.data.id,"vip_level"});
    if leftTime>0 and tonumber(DataCenter.vipData.level) >= needVip then
        if DataCenter.neverTip:getNeverValue("Lua_HookPushItem") == true then
            self:openTipsWindow();
        else
            if self.statetest == 0 then
                self:openTipsWindow();
            else
                local tipData = {};
                tipData.des = LanUtil.formateStr(LanUtil.getValue(128306), tostring(self.data.desc));
                tipData.neverTip = "Lua_HookPushItem";
                tipData.owner = self;
                tipData.type = 1;
                tipData.subFun = self.openTipsWindow;   --确定
                Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
            end
        end
    else
        local tipData = {};
        tipData.des = LanUtil.getValue(128304);
        tipData.owner = self;
        tipData.type = 1;
        tipData.subFun = self.openVIPWindow;   --确定
        tipData.cancelFun = self.onSubClick;  -- 取消
        tipData.subName = LanUtil.getValue(120862);
        tipData.cancelName = LanUtil.getValue(10016);
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
    end
end
function Lua_ActivitiesPushItem:openTipsWindow()
    if self.statetest == 0 then
        self.btnSprite:setLocation(50,0,0);
        self.statetest = 1;
        self.switchTips.text=LanUtil.getValue(128307);
        self.switchTips:setLocation(6.5,0,0);
        self.btnBg:setAltas("settingsWindow", "pushBoxBg_open");
    else
        self.btnSprite:setLocation(5,0,0);
        self.statetest = 0;
        self.switchTips.text=LanUtil.getValue(128308);
        self.switchTips:setLocation(28,0,0);
        self.btnBg:setAltas("settingsWindow", "pushBoxBg");
    end
    self.data.state=self.statetest;
    local dic={};
    dic.state=self.statetest
    dic.id=self.data.id
    Lua_MsgUtil.callFunc("setBtnState",dic);
end
function Lua_ActivitiesPushItem:openVIPWindow()
    Lua_WindowUtil.openWin("Lua_ChongzhiWindow",nil,10097);
    Lua_WindowUtil.openWin("Lua_SettingsWindow",WinParam.ACTION_CLOSE, nil);
end
function Lua_ActivitiesPushItem:setLockState(val)
    self.statetest = tonumber(val);
    if self.statetest == 0 then
        self.btnSprite:setLocation(5,0,0);
        self.switchTips.text=LanUtil.getValue(128308);
        self.switchTips:setLocation(28,0,0);
        self.btnBg:setAltas("settingsWindow", "pushBoxBg");
    else
        self.btnSprite:setLocation(50,0,0);
        self.switchTips.text=LanUtil.getValue(128307);
        self.switchTips:setLocation(6.5,0,0);
        self.btnBg:setAltas("settingsWindow", "pushBoxBg_open");
    end
end

function Lua_ActivitiesPushItem:dispose()
    self:superCall("dispose");
end



---------------------------------------------------------
Lua_HookPushItem = class("Lua_HookPushItem", Lua_ListCell);
function Lua_HookPushItem:ctor(p)
    self:superCall("ctor", p, "HookPushItem_skin");
end
function Lua_HookPushItem:buildShowItem()
    self:superCall("buildShowItem");
    self.btnBg:addClickFuntion(self,self.onLockBgClick);
end
function Lua_HookPushItem:setData(data)
    self.data = data;
    if self.data==nil then
        return;
    end
    self.nameLb.text=data.desc;
    self:setLockState(self.data.state);
end
function Lua_HookPushItem:onLockBgClick(go)
    local leftTime =tonumber(DataCenter.vipData.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
    local needVip=getConfig({"PrivatePush",self.data.id,"vip_level"});
    if leftTime>0 and tonumber(DataCenter.vipData.level) >= needVip then
        if DataCenter.neverTip:getNeverValue("Lua_HookPushItem") == true then
            self:openTipsWindow();
        else
            if self.statetest == 0 then
                self:openTipsWindow();
            else
                local tipData = {};
                tipData.des = LanUtil.formateStr(LanUtil.getValue(128306), tostring(self.data.desc));
                tipData.neverTip = "Lua_HookPushItem";
                tipData.owner = self;
                tipData.type = 1;
                tipData.subFun = self.openTipsWindow;   --确定
                Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
            end
        end
    else
        local tipData = {};
        tipData.des = LanUtil.getValue(128304);
        tipData.owner = self;
        tipData.type = 1;
        tipData.subFun = self.openVIPWindow;   --确定
        tipData.cancelFun = self.onSubClick;  -- 取消
        tipData.subName = LanUtil.getValue(120862);
        tipData.cancelName = LanUtil.getValue(10016)
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
    end
end
function Lua_HookPushItem:openVIPWindow()
    Lua_WindowUtil.openWin("Lua_ChongzhiWindow",nil,10097);
    Lua_WindowUtil.openWin("Lua_SettingsWindow",WinParam.ACTION_CLOSE, nil);
end
function Lua_HookPushItem:openTipsWindow()
    if self.statetest == 0 then
        self.btnSprite:setLocation(50,0,0);
        self.statetest = 1;
        self.switchTips.text=LanUtil.getValue(128307);
        self.switchTips:setLocation(6.5,0,0);
        self.btnBg:setAltas("settingsWindow", "pushBoxBg_open");
    else
        self.btnSprite:setLocation(5,0,0);
        self.statetest = 0;
        self.switchTips.text=LanUtil.getValue(128308);
        self.switchTips:setLocation(28,0,0);
        self.btnBg:setAltas("settingsWindow", "pushBoxBg");
    end
    self.data.state=self.statetest;
    local dic={};
    dic.state=self.statetest
    dic.id=self.data.id
    Lua_MsgUtil.callFunc("setBtnState",dic);
end
function Lua_HookPushItem:setLockState(val)
    self.statetest = tonumber(val);
    if self.statetest == 0 then
        self.btnSprite:setLocation(5,0,0);
        self.switchTips.text=LanUtil.getValue(128308);
        self.switchTips:setLocation(28,0,0);
        self.btnBg:setAltas("settingsWindow", "pushBoxBg");
    else
        self.btnSprite:setLocation(50,0,0);
        self.switchTips.text=LanUtil.getValue(128307);
        self.switchTips:setLocation(6.5,0,0);
        self.btnBg:setAltas("settingsWindow", "pushBoxBg_open");
    end
end

function Lua_HookPushItem:dispose()
    self:superCall("dispose");
end