Lua_SysPanel = class("Lua_SysPanel", Lua_DisplayObject);
function Lua_SysPanel:ctor(p)
	self:superCall("ctor", p, "SysBasicPanel_skin", true);
end

function Lua_SysPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.changeIdBtn:addClickFuntion(self,self.onChangeIdBtn);
	self.stuckBtn:addClickFuntion(self,self.onStuckIdBtn);
	self.versionBtn:addClickFuntion(self,self.onVersionClick);

	if getLanType() == 1 then
		self.clientBtn = UICreate.createButton(self.content, "고객센터", -520, -315, 146, 56);
		self.clientBtn.name = "backBtn";
		self.clientBtn.txt.colorStr = "4285803520";
		self.clientBtn:addClickFuntion(self,self.onClientClick);
	end

	self.versionBtn:setEnable(false);
	if getShowTips() == false and DataCenter.showVersion ~= true then
		self.versionBtn:setEnable(false);
	else
		self.versionBtn:setEnable(true);
	end

	self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(-64, 12, 1118, 520));
	self.dragContainer:setLocation(0, 0, 0);
	self.dragContainer.uiPanel.depth = 3000;
	self.draggableSysPanel = Lua_DraggableSysPanel.new(self.dragContainer);
end

function Lua_SysPanel:dispose()
	if(self.dragList~=nil) then 
		self.dragList:dispose(); 
		self.dragList=nil; 
	end
	self:superCall("dispose");
end
function Lua_SysPanel:onClientClick(o)
	MsgUtil.callFunc("OPEN_CS_CENTER");
end
function Lua_SysPanel:onChangeIdBtn()
	if getLanType() == 1 then
		self:onOutLogin();
	else
		local tipData = {};
		tipData.des = LanUtil.getValue(110221);  
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.onOutLogin;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end
function Lua_SysPanel:onOutLogin(o)
	LuaUtil.relogin();

	DataCenter.investmentPlanData.peakInvestmentOpen = nil;
end

function Lua_SysPanel:onStuckIdBtn()
	local rd = DataCenter.roleData;
	local vec = WorldMapUtil.getYByXZ(rd.px, rd.pz);
	if vec == nil or (vec.x == -100000 and vec.y == -100000 and vec.z == -100000) then
		local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
		local rpos = sceneCfg.relive_pos; 
		if rpos.x == -1 and rpos.y == -1 and rpos.z == -1 then
			OperateAlert.show(LanUtil.getValue(107497));
		else
			Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(DataCenter.roleData.sceneId, rpos.x, rpos.y, rpos.z, 0);
			Lua_WindowUtil.openWin("Lua_SettingsWindow");
		end
	else
		OperateAlert.show(LanUtil.getValue(107496));
	end
end

function Lua_SysPanel:onVersionClick(o)
	Lua_WindowUtil.openWin("Lua_VersionWindow");
end

Lua_DraggableSysPanel = class("Lua_DraggableSysPanel", Lua_DragContainerItem);
function Lua_DraggableSysPanel:ctor(dragContainer)
	self.isInit = false;
	self:superCall("ctor", dragContainer.sub, "SysPanel_skin");
	dragContainer:addSubContainer(self,true);
end
function Lua_DraggableSysPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("SYS_PANEL_UPDATE", self, self.updatePanel);

	self:setPrg(self.musicPrg,100,50,self.onMusicSlideing,self.onMusicSlideing);
	self:setPrg(self.soundPrg,100,50,self.onSoundSlideing,self.onSoundSlideing);
	self:setPrg(self.qualityPrg,100,50,self.onQualitySlideing,self.onQualitySlideing);
	self:setPrg(self.playerNumPrg,20,5,self.onPlayerNumSlideing,self.onPlayerNumSlideing);
	self:setPrg(self.monsterNumPrg,20,5,self.onMonsterNumSlideing,self.onMonsterNumSlideing);

	self.musicChk:addBoxChange(self, self.onMusicChange);
	self.soundChk:addBoxChange(self, self.onSoundChange);

	self.perspectiveChk1:addBoxChange(self, self.onPerspectiveChange1);
	self.perspectiveChk2:addBoxChange(self, self.onPerspectiveChange2);

	self.qualityChk1:addBoxChange(self, self.onQualityChange1);
	self.qualityChk2:addBoxChange(self, self.onQualityChange2);
	self.qualityChk3:addBoxChange(self, self.onQualityChange3);

	self.shieldTypeChk1:addBoxChange(self, self.onShieldChange1);
	self.shieldTypeChk2:addBoxChange(self, self.onShieldChange2);
	self.shieldTypeChk3:addBoxChange(self, self.onShieldChange3);
	self.shieldTypeChk4:addBoxChange(self, self.onShieldChange4);
	self.shieldTypeChk5:addBoxChange(self, self.onShieldChange5);
	self.shieldTypeChk6:addBoxChange(self, self.onShieldChange6);
	self.shieldTypeChk7:addBoxChange(self, self.onShieldChange7);

	self:updatePanel();
end

function Lua_DraggableSysPanel:updatePanel()
	--音乐音效
	local pd = PlayerData.getInstance();
	self.musicChk.seleted = pd:getSettingValue("IS_PLAY_MUSIC") == 1;
	self.musicPrg:setValue(pd:getSettingValue("MUSIC_VOLUME"));
	self.soundChk.seleted = pd:getSettingValue("IS_PLAY_SOUND") == 1;
	self.soundPrg:setValue(pd:getSettingValue("SOUND_VOLUME"));

	self:setPerspective(pd:getSettingValue("SCREEN_TYPE"));
	self:setFluencyType(pd:getSettingValue("FLUENCY_TYPE"));

	self.shieldTypeChk1.seleted = pd:getSettingValue("SHIELD_OTHER_SKILL") == 1;
	self.shieldTypeChk2.seleted = pd:getSettingValue("SHIELD_OTHER_PET") == 1;
	self.shieldTypeChk3.seleted = pd:getSettingValue("SHIELD_MYEFFECT") == 1;
	self.shieldTypeChk4.seleted = pd:getSettingValue("SHIELD_SCENE_EFFECT") == 1;
	self.shieldTypeChk5.seleted = pd:getSettingValue("SHIELD_DROP_NAME") == 1;
	self.shieldTypeChk6.seleted = pd:getSettingValue("SHIELD_FRIEND") == 1;
	self.shieldTypeChk7.seleted = pd:getSettingValue("IS_SHOCK") == 1;
	if self.nightPushChk ~= nil then
		self.nightPushChk.seleted = DataCenter.hangUpSettingsData.auto_back_main == 1;
	end

	self.qualityPrg:setValue(pd:getSettingValue("QUALITY_NUM"));
	self.playerNumPrg:setValue(pd:getSettingValue("SHOW_PLAYER_NUM"));
	self.monsterNumPrg:setValue(pd:getSettingValue("SHOW_MONSTER_NUM"));

	self.isInit = true;
end

function Lua_DraggableSysPanel:setPrg(prg,maxValue,value,slideEndFun,slideingFun)
	if(self.prgList ==nil) then self.prgList=Array(); end
	self.prgList:add(prg);
	prg:setText("");
	prg:createSlider("settingsWindow_atlas","ui_shezhi_widget_01");
	prg:addSlideEndFun(self,slideEndFun);
	prg:addSlidingFun(self,slideingFun);
	prg:setMaxValue(maxValue);
	prg:setValue(value);
end

function Lua_DraggableSysPanel:onMusicSlideing(val)
	if self.isInit == true then
		local pd = PlayerData.getInstance();
		pd:setSettingValue("MUSIC_VOLUME", val);
		MsgUtil.callFunc("PLAY_MUSIC_VOLUME_CHANGE");
	end
end

function Lua_DraggableSysPanel:onSoundSlideing(val)
	if self.isInit == true then
		local pd = PlayerData.getInstance();
		pd:setSettingValue("SOUND_VOLUME", val);
	end
end

function Lua_DraggableSysPanel:onQualitySlideing(val, checkChange)
	if self.isInit == true then
		local pd = PlayerData.getInstance();
		pd:setSettingValue("QUALITY_NUM", val);
	end
	if val < 33 then
		self.qualityTxt.text = LanUtil.formateStr(LanUtil.getValue(110213), LanUtil.getValue(110216));
	elseif val < 66 then
		self.qualityTxt.text = LanUtil.formateStr(LanUtil.getValue(110213), LanUtil.getValue(110217));
	else
		self.qualityTxt.text = LanUtil.formateStr(LanUtil.getValue(110213), LanUtil.getValue(110218));
	end
	if checkChange ~= false then
		self:changeFluency();
	end
end

function Lua_DraggableSysPanel:onPlayerNumSlideing(val, checkChange)
	if self.isInit == true then
		local pd = PlayerData.getInstance();
		pd:setSettingValue("SHOW_PLAYER_NUM", val);
		MsgUtil.callFunc("UPDATE_SHIELD");
	end
	self.playerNumTxt.text = LanUtil.formateStr(LanUtil.getValue(110214), tostring(val));
	if checkChange ~= false then
		self:changeFluency();
	end
end

function Lua_DraggableSysPanel:onMonsterNumSlideing(val, checkChange)
	if self.isInit == true then
		local pd = PlayerData.getInstance();
		pd:setSettingValue("SHOW_MONSTER_NUM", val);
		MsgUtil.callFunc("UPDATE_SHIELD");
	end
	self.monsterNumTxt.text = LanUtil.formateStr(LanUtil.getValue(110215), tostring(val));
	if checkChange ~= false then
		self:changeFluency();
	end
end

function Lua_DraggableSysPanel:onMusicChange(val)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("IS_PLAY_MUSIC", val == true and 1 or 0);
	MsgUtil.callFunc("PLAY_MUSIC_CHANGE");
end

function Lua_DraggableSysPanel:onSoundChange(val)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("IS_PLAY_SOUND", val == true and 1 or 0);
end

function Lua_DraggableSysPanel:onPerspectiveChange1(val)
	self:setPerspective(1);
end

function Lua_DraggableSysPanel:onPerspectiveChange2(val)
	self:setPerspective(2);
end

function Lua_DraggableSysPanel:setPerspective(val)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("SCREEN_TYPE", val);
	self.perspectiveChk1.seleted = val == 1;
	self.perspectiveChk2.seleted = val == 2;
end

function Lua_DraggableSysPanel:onQualityChange1(val)
	self:setFluencyType(1);
end

function Lua_DraggableSysPanel:onQualityChange2(val)
	self:setFluencyType(2);
end

function Lua_DraggableSysPanel:onQualityChange3(val)
	self:setFluencyType(3);
end

function Lua_DraggableSysPanel:changeFluency()
	local pd = PlayerData.getInstance();
	local v = pd:getSettingValue("FLUENCY_TYPE");
	if (self.changingFluency == nil or self.changingFluency == false) and v ~= 2 then
		self:setFluencyType(2);
	end
end

function Lua_DraggableSysPanel:setFluencyType(val)
	local pd = PlayerData.getInstance();
	self.changingFluency = true;
	pd:setSettingValue("FLUENCY_TYPE", val);
	self.qualityChk1.seleted = val == 1;
	self.qualityChk2.seleted = val == 2;
	self.qualityChk3.seleted = val == 3;
	if val == 1 then
		self:onShieldChange1(false, false);
		self.shieldTypeChk1.seleted = false;
		self:onShieldChange2(false, false);
		self.shieldTypeChk2.seleted = false;
		self:onShieldChange3(false, false);
		self.shieldTypeChk3.seleted = false;
		self:onShieldChange4(false, false);
		self.shieldTypeChk4.seleted = false;
		self:onShieldChange5(false, false);
		self.shieldTypeChk5.seleted = false;
		self:onShieldChange6(false, false);
		self.shieldTypeChk6.seleted = false;

		self:onQualitySlideing(100, false);
		self.qualityPrg:setValue(100);
		self:onPlayerNumSlideing(20, false);
		self.playerNumPrg:setValue(20);
		self:onMonsterNumSlideing(20, false);
		self.monsterNumPrg:setValue(20);
	elseif val == 3 then
		self:onShieldChange1(true, false);
		self.shieldTypeChk1.seleted = true;
		self:onShieldChange2(true, false);
		self.shieldTypeChk2.seleted = true;
		self:onShieldChange3(true, false);
		self.shieldTypeChk3.seleted = true;
		self:onShieldChange4(true, false);
		self.shieldTypeChk4.seleted = true;
		self:onShieldChange5(true, false);
		self.shieldTypeChk5.seleted = true;
		self:onShieldChange6(true, false);
		self.shieldTypeChk6.seleted = true;

		self:onQualitySlideing(0, false);
		self.qualityPrg:setValue(0);
		self:onPlayerNumSlideing(0, false);
		self.playerNumPrg:setValue(0);
		self:onMonsterNumSlideing(0, false);
		self.monsterNumPrg:setValue(0);
	end
	self.changingFluency = false;
end
function Lua_DraggableSysPanel:onShieldChange1(val, checkChange)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("SHIELD_OTHER_SKILL", val and 1 or 0);
	if checkChange ~= false then
		self:changeFluency();
	end
end

function Lua_DraggableSysPanel:onShieldChange2(val, checkChange)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("SHIELD_OTHER_PET", val and 1 or 0);
	MsgUtil.callFunc("UPDATE_SHIELD");
	DataCenter.thingData:updateThingPlayerShieldState();
	if checkChange ~= false then
		self:changeFluency();
	end
end

function Lua_DraggableSysPanel:onShieldChange3(val, checkChange)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("SHIELD_MYEFFECT", val and 1 or 0);
	MsgUtil.callFunc("UPDATE_SHIELD");
	DataCenter.thingData:updateThingPlayerShieldState();
	if checkChange ~= false then
		self:changeFluency();
	end
end
function Lua_DraggableSysPanel:onShieldChange4(val, checkChange)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("SHIELD_SCENE_EFFECT", val and 1 or 0);
	MsgUtil.callFunc("UPDATE_SHIELD");
	if checkChange ~= false then
		self:changeFluency();
	end
end
function Lua_DraggableSysPanel:onShieldChange5(val, checkChange)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("SHIELD_DROP_NAME", val and 1 or 0);
	MsgUtil.callFunc("UPDATE_SHIELD");
	if checkChange ~= false then
		self:changeFluency();
	end
end
function Lua_DraggableSysPanel:onShieldChange6(val, checkChange)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("SHIELD_FRIEND", val and 1 or 0);
	MsgUtil.callFunc("UPDATE_SHIELD");
	if checkChange ~= false then
		self:changeFluency();
	end
end
function Lua_DraggableSysPanel:onShieldChange7(val, checkChange)
	local pd = PlayerData.getInstance();
	pd:setSettingValue("IS_SHOCK", val and 1 or 0);
	if checkChange ~= false then
		self:changeFluency();
	end
end

--------------------------------------------------------
function Lua_DraggableSysPanel:getWidth()
	return 500;
end
function Lua_DraggableSysPanel:getHeight()
	return 755;
end